perf ipsec: test renaming
[csit.git] / bootstrap-vpp-verify-nightly.sh
1 #!/bin/bash
2 # Copyright (c) 2017 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a ght (c) 2016 Cisco and/or its affiliates.
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not usecopy of the License at:
8 #
9 #     http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16
17 set -x
18
19 cat /etc/hostname
20 cat /etc/hosts
21
22 ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
23
24 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
25 export PYTHONPATH=${SCRIPT_DIR}
26
27 # Create tmp dir
28 mkdir ${SCRIPT_DIR}/tmp
29
30 # Use tmp dir for tarballs
31 export TMPDIR="${SCRIPT_DIR}/tmp"
32
33 # Use tmp dir to store log files
34 LOG_PATH="$TMPDIR"
35
36 if [ -f "/etc/redhat-release" ]; then
37     DISTRO="CENTOS"
38     sudo yum install -y python-devel python-virtualenv
39     PACKAGE=rpm
40 else
41     DISTRO="UBUNTU"
42     export DEBIAN_FRONTEND=noninteractive
43     sudo apt-get -y update
44     sudo apt-get -y install libpython2.7-dev python-virtualenv
45     PACKAGE=deb
46 fi
47
48 # 1st step: Download and prepare VPP packages
49
50 # Temporarily download VPP packages from nexus.fd.io
51 if [ "${#}" -ne "0" ]; then
52     arr=(${@})
53     echo ${arr[0]}
54 else
55     # Download the latest VPP build install packages
56     rm -f *.${PACKAGE}
57     echo Downloading VPP packages...
58     CSIT_DIR=${SCRIPT_DIR}
59     source "${SCRIPT_DIR}/resources/libraries/bash/function/artifacts.sh"
60     download_artifacts
61     # Need to revert -euo as the rest of script is not optimized for this.
62     set +euo pipefail
63 fi
64
65 # Take vpp package and get the vpp version
66 VPP_PKGS=(*.$PACKAGE)
67 case "$DISTRO" in
68         CENTOS )
69             VPP_VER="$( expr match $(ls *.rpm | head -n 1) 'vpp-\(.*\).rpm' )"
70             ;;
71         UBUNTU )
72             VPP_VER="$( expr match $(ls *.deb | head -n 1) 'vpp-\(.*\)-deb.deb' )"
73 esac
74
75 echo ${VPP_PKGS[@]}
76
77 set +x
78 echo "****************************************************************************************************************************************"
79 echo "1st step: Download VPP packages                                                                                                 FINISHED"
80 echo "VPP version to be tested: ${VPP_VER}"
81 echo "****************************************************************************************************************************************"
82 set -x
83
84
85 # 2nd step: Start virtual env and install requirements
86
87 echo Starting virtual env...
88 virtualenv --system-site-packages env
89 . env/bin/activate
90
91 echo Installing requirements...
92 pip install -r ${SCRIPT_DIR}/requirements.txt
93
94 set +x
95 echo "****************************************************************************************************************************************"
96 echo "2nd step: Start virtual env and install requirements                                                                            FINISHED"
97 echo "****************************************************************************************************************************************"
98 set -x
99
100
101 # 3rd step: Prepare VIRL system
102 echo Preparing VIRL system...
103
104 VIRL_SERVERS=("10.30.51.28" "10.30.51.29" "10.30.51.30")
105 IPS_PER_VIRL=( "10.30.51.28:252"
106                "10.30.51.29:74"
107                "10.30.51.30:74" )
108 SIMS_PER_VIRL=( "10.30.51.28:13"
109                "10.30.51.29:13"
110                "10.30.51.30:13" )
111 IPS_PER_SIMULATION=5
112
113 function get_max_ip_nr() {
114     virl_server=$1
115     IP_VALUE="0"
116     for item in "${IPS_PER_VIRL[@]}" ; do
117         if [ "${item%%:*}" == "${virl_server}" ]
118         then
119             IP_VALUE=${item#*:}
120             break
121         fi
122     done
123     echo "$IP_VALUE"
124 }
125
126 function get_max_sim_nr() {
127     virl_server=$1
128     SIM_VALUE="0"
129     for item in "${SIMS_PER_VIRL[@]}" ; do
130         if [ "${item%%:*}" == "${virl_server}" ]
131         then
132             SIM_VALUE=${item#*:}
133             break
134         fi
135     done
136     echo "$SIM_VALUE"
137 }
138
139 VIRL_USERNAME=jenkins-in
140 VIRL_PKEY=priv_key
141 VIRL_SERVER_STATUS_FILE="status"
142 VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
143
144 SKIP_PATCH="skip_patchORskip_vpp_patch"
145
146 case "$DISTRO" in
147         CENTOS )
148             VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_CENTOS)
149             VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_CENTOS)
150             NON_CRITICAL_TESTS="expected_failingORvm"
151             ;;
152         UBUNTU )
153             VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_UBUNTU)
154             VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_UBUNTU)
155             NON_CRITICAL_TESTS="EXPECTED_FAILING"
156             ;;
157 esac
158
159 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
160
161 function ssh_do() {
162     echo
163     echo "### "  ssh $@
164     ssh ${SSH_OPTIONS} $@
165 }
166
167 rm -f ${VIRL_PKEY}
168 cat > ${VIRL_PKEY} <<EOF
169 -----BEGIN RSA PRIVATE KEY-----
170 MIIEpQIBAAKCAQEA+IHXq87GcqMR1C47rzx6Cbip5Ghq8pKrbqKrP5Nf41HcYrT6
171 GOXl9nFWKsMOzIlIn+8y7Il27eZh7csQGApbg8QLiHMtcYEmWNzKZpkqg4nuAPxX
172 VXwlKgnKX902SrET9Gp9TDayiHtCRWVfrlPPPSA0UEXW6BjLN/uHJ+W/Xzrrab+9
173 asBVa05vT2W6n0KJ66zfCaeDM912mQ6SttscAwFoWDmdHlegiVqrlIG2ABxOvxxz
174 L3dM3iSmlmQlzv9bThjo+nI4KFYh6m5wrZmAo5r/4q9CIJc21HVnTqkGOWJIZz6J
175 73lePJVSq5gYqaoGw3swFEA/MDkOx7baWKSoLQIDAQABAoIBAQCNBeolNp+JWJ76
176 gQ4fwLsknyXSV6sxYyhkDW4PEwwcTU06uqce0AAzXVffxne0fMe48x47+zqBgPbb
177 4huM+Pu8B9nfojUMr5TaYtl9Zbgpk3F8H7dT7LKOa6XrxvZTZrADSRc30+Z26zPN
178 e9zTaf42Gvt0/l0Zs1BHwbaOXqO+XuwJ3/F9Sf3PQYWXD3EOWjpHDP/X/1vAs6lV
179 SLkm6J/9KKE1m6I6LTYjIXuYt4SXybW6N2TSy54hhQtYcDUnIU2hR/PHVWKrGA0J
180 kELgrtTNTdbML27O5gFWU4PLUEYTZ9fN11D6qUZKxLcPOiPPHXkiILMRCCnG5DYI
181 ksBAU/YlAoGBAPxZO9VO18TYc8THV1nLKcvT2+1oSs1UcA2wNQMU55t910ZYinRa
182 MRwUhMOf8Mv5wOeiZaRICQB1PnVWtDVmGECgPpK6jUxqAwn8rgJcnoafLGL5YKMY
183 RVafTe6N5LXgCaOcJrk21wxs6v7ninEbUxxc575urOvZMBkymDw91dwbAoGBAPwa
184 YRhKhrzFKZzdK0RadVjnxKvolUllpoqqg3XuvmeAJHAOAnaOgVWq68NAcp5FZJv0
185 2D2Up7TX8pjf9MofP1SJbcraKBpK4NzfNkA0dSdEi+FhVofAJ9umB2o5LW1n7sab
186 UIrjsdzSJK/9Zb9yTTHPyibYzNEgaJV1HsbxfEFXAoGAYO2RmvRm0phll18OQVJV
187 IpKk9kLKAKZ/R/K32hAsikBC8SVPQTPniyaifFWx81diblalff2hX4ipTf7Yx24I
188 wMIMZuW7Im/R7QMef4+94G3Bad7p7JuE/qnAEHJ2OBnu+eYfxaK35XDsrq6XMazS
189 NqHE7hOq3giVfgg+C12hCKMCgYEAtu9dbYcG5owbehxzfRI2/OCRsjz/t1bv1seM
190 xVMND4XI6xb/apBWAZgZpIFrqrWoIBM3ptfsKipZe91ngBPUnL9s0Dolx452RVAj
191 yctHB8uRxWYgqDkjsxtzXf1HnZBBkBS8CUzYj+hdfuddoeKLaY3invXLCiV+PpXS
192 U4KAK9kCgYEAtSv0m5+Fg74BbAiFB6kCh11FYkW94YI6B/E2D/uVTD5dJhyEUFgZ
193 cWsudXjMki8734WSpMBqBp/J8wG3C9ZS6IpQD+U7UXA+roB7Qr+j4TqtWfM+87Rh
194 maOpG56uAyR0w5Z9BhwzA3VakibVk9KwDgZ29WtKFzuATLFnOtCS46E=
195 -----END RSA PRIVATE KEY-----
196 EOF
197 chmod 600 ${VIRL_PKEY}
198
199 #
200 # The server must be reachable and have a "status" file with
201 # the content "PRODUCTION" to be selected.
202 #
203 # If the server is not reachable or does not have the correct
204 # status remove it from the array and start again.
205 #
206 # Abort if there are no more servers left in the array.
207 #
208 VIRL_PROD_SERVERS=()
209 for index in "${!VIRL_SERVERS[@]}"; do
210     virl_server_status=$(ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVERS[$index]} cat $VIRL_SERVER_STATUS_FILE 2>&1)
211     echo VIRL HOST ${VIRL_SERVERS[$index]} status is \"$virl_server_status\"
212     if [ "$virl_server_status" == "$VIRL_SERVER_EXPECTED_STATUS" ]
213     then
214         # Candidate is in good status. Add to array.
215         VIRL_PROD_SERVERS+=(${VIRL_SERVERS[$index]})
216     fi
217 done
218
219 VIRL_SERVERS=("${VIRL_PROD_SERVERS[@]}")
220 echo "VIRL servers in production: ${VIRL_SERVERS[@]}"
221 num_hosts=${#VIRL_SERVERS[@]}
222 if [ $num_hosts == 0 ]
223 then
224     echo "No more VIRL candidate hosts available, failing."
225     exit 127
226 fi
227
228 # Get the LOAD of each server based on number of active simulations (test cases)
229 VIRL_SERVER_LOAD=()
230 for index in "${!VIRL_SERVERS[@]}"; do
231     VIRL_SERVER_LOAD[${index}]=$(ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVERS[$index]} "list-testcases | grep session | wc -l")
232 done
233
234 # Pick the least loaded server
235 VIRL_SERVER=""
236 least_load_server_idx=$(echo "${VIRL_SERVER_LOAD[*]}" | tr -s ' ' '\n' | awk '{print($0" "NR)}' | sort -g -k1,1 | head -1 | cut -f2 -d' ')
237 least_load_server=${VIRL_SERVERS[$least_load_server_idx-1]}
238 VIRL_SERVER=($least_load_server)
239
240 echo "Selected VIRL servers: ${VIRL_SERVER[@]}"
241
242 VIRL_DIR_LOC="/tmp"
243 VPP_PKGS_VIRL=(${VPP_PKGS[@]})
244
245 # Prepend directory location at remote host to package file list
246 for index in "${!VPP_PKGS_VIRL[@]}"; do
247     VPP_PKGS_VIRL[${index}]=${VIRL_DIR_LOC}/${VPP_PKGS_VIRL[${index}]}
248 done
249
250 echo "Updated file names: " ${VPP_PKGS_VIRL[@]}
251
252 cat ${VIRL_PKEY}
253 # Copy the files to VIRL host
254 scp ${SSH_OPTIONS} *.${PACKAGE} \
255     ${VIRL_USERNAME}@${VIRL_SERVER}:${VIRL_DIR_LOC}/
256
257 result=$?
258 if [ "${result}" -ne "0" ]; then
259     echo "Failed to copy vpp package files to virl host"
260     echo ${result}
261     exit ${result}
262 fi
263
264 function stop_virl_simulation {
265     ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVER}\
266         "stop-testcase ${VIRL_SID}"
267 }
268
269 # Upon script exit, cleanup the VIRL simulation execution
270 trap stop_virl_simulation EXIT
271
272 # Start a simulation on VIRL server
273 echo "Starting simulation on VIRL server"
274
275 # Get given VIRL server limits for max. number of VMs and IPs
276 max_ips=$(get_max_ip_nr ${VIRL_SERVER})
277 max_ips_from_sims=$(($(get_max_sim_nr ${VIRL_SERVER[${index}]})*IPS_PER_SIMULATION))
278 # Set quota to lower value
279 IP_QUOTA=$([ $max_ips -le $max_ips_from_sims ] && echo "$max_ips" || echo "$max_ips_from_sims")
280
281 # Start the simulation
282 VIRL_SID=$(ssh ${SSH_OPTIONS} \
283     ${VIRL_USERNAME}@${VIRL_SERVER} \
284     "start-testcase -vv --quota ${IP_QUOTA} --copy ${VIRL_TOPOLOGY} \
285     --release ${VIRL_RELEASE} ${VPP_PKGS_VIRL[@]}")
286 retval=$?
287 if [ ${retval} -ne "0" ]; then
288     echo "VIRL simulation start failed on ${VIRL_SERVER}"
289     exit ${retval}
290 fi
291
292 if [[ ! "${VIRL_SID}" =~ session-[a-zA-Z0-9_]{6} ]]; then
293     echo "No VIRL session ID reported."
294     exit 127
295 fi
296
297 echo ${VIRL_SID}
298
299 ssh_do ${VIRL_USERNAME}@${VIRL_SERVER} cat /scratch/${VIRL_SID}/topology.yaml
300
301 # Download the topology file from VIRL session
302 scp ${SSH_OPTIONS} \
303     ${VIRL_USERNAME}@${VIRL_SERVER}:/scratch/${VIRL_SID}/topology.yaml \
304     topologies/enabled/topology_VIRL.yaml
305
306 retval=$?
307 if [ ${retval} -ne "0" ]; then
308     echo "Failed to copy topology file from VIRL simulation"
309     exit ${retval}
310 fi
311
312 set +x
313 echo "****************************************************************************************************************************************"
314 echo "3rd step: Start the simulation on the VIRL server                                                                               FINISHED"
315 echo "****************************************************************************************************************************************"
316 set -x
317
318
319 # 4th step: Run functional test suites
320
321 pykwalify -s ${SCRIPT_DIR}/resources/topology_schemas/3_node_topology.sch.yaml \
322           -s ${SCRIPT_DIR}/resources/topology_schemas/topology.sch.yaml \
323           -d ${SCRIPT_DIR}/topologies/enabled/topology_VIRL.yaml \
324           -vvv
325 if [ "$?" -ne "0" ]; then
326     echo "Topology schema validation failed."
327     echo "However, the tests will start."
328 fi
329
330 echo Running functional tests on the VIRL system...
331
332 echo "PYTHONPATH=`pwd` pybot -L TRACE -W 136\
333     -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology_VIRL.yaml \
334     --suite "tests.func" \
335     --include vm_envAND3_node_single_link_topo \
336     --include vm_envAND3_node_double_link_topo \
337     --exclude PERFTEST \
338     --exclude ${SKIP_PATCH} \
339     --noncritical ${NON_CRITICAL_TESTS} \
340     --outputdir ${LOG_PATH} \
341     tests/"
342
343 PYTHONPATH=`pwd` pybot -L TRACE -W 136\
344     -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology_VIRL.yaml \
345     --suite "tests.func" \
346     --include vm_envAND3_node_single_link_topo \
347     --include vm_envAND3_node_double_link_topo \
348     --exclude PERFTEST \
349     --exclude ${SKIP_PATCH} \
350     --noncritical ${NON_CRITICAL_TESTS} \
351     --outputdir ${LOG_PATH} \
352     tests/
353 RC=$(echo $?)
354
355 set +x
356 echo "****************************************************************************************************************************************"
357 echo "4th step: Run functional tests                                                                                                  FINISHED"
358 echo "****************************************************************************************************************************************"
359 set -x
360
361 # Log the final result
362 if [ ${RC} -eq 0 ]; then
363     RETURN_STATUS=0
364     set +x
365     echo
366     echo "========================================================================================================================================"
367     echo "Final result of all tests:                                                                                                      | PASS |"
368     echo "All critical tests have passed."
369     echo "========================================================================================================================================"
370     echo
371     set -x
372 elif [ ${MORE_FAILS} -eq 0 ]; then
373     RETURN_STATUS=1
374     if [ ${RC} -eq 1 ]; then
375         HLP_STR="test has"
376     else
377         HLP_STR="tests have"
378     fi
379     set +x
380     echo
381     echo "========================================================================================================================================"
382     echo "Final result of all tests:                                                                                                      | FAIL |"
383     echo "${RC} critical ${HLP_STR} failed."
384     echo "========================================================================================================================================"
385     echo
386     set -x
387 else
388     RETURN_STATUS=1
389     set +x
390     echo
391     echo "========================================================================================================================================"
392     echo "Final result of all tests:                                                                                                      | FAIL |"
393     echo "More then 250 critical tests have failed in one test loop."
394     echo "========================================================================================================================================"
395     echo
396     set -x
397 fi
398
399
400 # 5th step: Archive artifacts
401 mkdir archive
402 for i in ${ARCHIVE_ARTIFACTS[@]}; do
403     cp $( readlink -f ${LOG_PATH}/${i} | tr '\n' ' ' ) archive/
404 done
405
406 echo Log files copied to archive directory.
407
408 exit ${RETURN_STATUS}

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.